--####################################################################################
-- written by ChrisOHara 14.01.2023
--
-- this software is freen, no garantee so it's uasage is on your own risc
--
-- this script is not designed to run on it's own.
-- it is a kind of library function so it can be loaded by other scripts.
--
-- the function reurns "magic" numbers for specific radios
--
-- return values are:
--
--   index number of first logical switch "ls01"
--   index number of first Switch "telemetry"
--   index of source "MAX"
--   index of dource "trn01"
--   index of source "ch01"
--   index of source "rud"
--
-- to be used for functions like model.setMixer()
--
--###########################################################



local function findingIndexes()

--##### defining of Indes for LS01, TR1, CH01, Max ### depends on radio Type ### x9Lite = 36

local indexSwitchLS01;		-- Switch ID for LS01
local indexSourceMAX;		-- Source ID of MAX Value for CustomFunction
local radioType;
local ver, radio, maj, minor, rev, osname = getVersion();
	_, _, radioType = string.find(radio, "(%w+)-")
	if radioType == nil then radioType = radio; end;


local lineSizeMID = 17;    -- for Taranis also small Displays
local lineSizeSML = 9;    -- for Taranis also small Displays

	if        radioType == "x9e"     then
			indexSwitchLS01 = 87;
			indexSourceTR01 = 177;
			indexSourceMAX = 87;
                        indexSourceRud = 75;
	   elseif radioType == "x9lites" then
			indexSwitchLS01 = 36;
			indexSourceTR01 = 159;
			indexSourceMAX = 80;
                        indexSourceRud = 75;
	   elseif radioType == "x9lite" then
			indexSwitchLS01 = 30;
			indexSourceTR01 = 157;
			indexSourceMAX = 80;
                        indexSourceRud = 75;
	   elseif radioType == "xlite" then
			indexSwitchLS01 = 39;
			indexSourceTR01 = 159;
			indexSourceMAX = 81;
                        indexSourceRud = 75;
	   elseif radioType == "xlites" then
			indexSwitchLS01 = 39;
			indexSourceTR01 = 161;
			indexSourceMAX = 83;
                        indexSourceRud = 75;
	   elseif radioType == "x9d+2019" then
			indexSwitchLS01 = 54 ;
			indexSourceTR01 = 165 ;
			indexSourceMAX = 84;
                        indexSourceRud = 75;
	   elseif radioType == "x9d+" then
			indexSwitchLS01 = 54 ;
			indexSourceTR01 = 165 ;
			indexSourceMAX = 84;
                        indexSourceRud = 75;
	   elseif radioType == "x9d" then
			indexSwitchLS01 = 54 ;
			indexSourceTR01 = 165 ;
			indexSourceMAX = 84;
                        indexSourceRud = 75;
	   elseif radioType == "x7access" then
			indexSwitchLS01 = 45 ;
			indexSourceTR01 = 161 ;
			indexSourceMAX = 81;
                        indexSourceRud = 75;
	   elseif radioType == "x7" then
			indexSwitchLS01 = 45 ;
			indexSourceTR01 = 161 ;
			indexSourceMAX = 81;
                        indexSourceRud = 75;
	   elseif radioType == "x10" then
			indexSwitchLS01 = 73 ;
			indexSourceTR01 = 184 ;
			indexSourceMAX = 100;
                        indexSourceRud = 87;
			lineSizeMID = 34;
			lineSizeSML = 18;    
	   elseif radioType == "x10express" then
			indexSwitchLS01 = 73 ;
			indexSourceTR01 = 184 ;
			indexSourceMAX = 100;
                        indexSourceRud = 87;
			lineSizeMID = 34;
			lineSizeSML = 18; 
	   elseif radioType == "x12s" then
			indexSwitchLS01 = 61 ;
			indexSourceTR01 = 184 ;
			indexSourceMAX = 100;
                        indexSourceRud = 87;
			lineSizeMID = 34;
			lineSizeSML = 18; 
	   else                               
			indexSwitchLS01 = 0;   -- catchall, if radio is not found
			indexSourceTR01 = 0;
			indexSourceMAX = 0;
                        indexSourceRud = 0;
	  end

local indexSourceCH01 =  indexSourceTR01 + 16;    -- index für Source Ch01
local indexSwitchTele =indexSwitchLS01 + 75;		  -- index für Telemetry on

return indexSwitchLS01, indexSourceTR01, indexSourceMAX, indexSourceCH01, indexSwitchTele, indexSourceRud, lineSizeMID, lineSizeSML;

end


return {init=findingIndexes}